﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;
using System.Web.Configuration;

public partial class EditableProductList : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            dlstProduct.DataSource = dsrcProduct;
            dlstProduct.DataBind();
        }
    }

    protected void dlstProduct_ItemCommand(object source, DataListCommandEventArgs e)
    {
        dlstProduct.SelectedIndex = e.Item.ItemIndex;

        dlstProduct.DataSource = dsrcProduct;
        dlstProduct.DataBind();
    }

    protected void dlstProduct_EditCommand(object source, DataListCommandEventArgs e)
    {
        dlstProduct.EditItemIndex = e.Item.ItemIndex;

        dlstProduct.DataSource = dsrcProduct;
        dlstProduct.DataBind();
    }

    protected void dlstProduct_UpdateCommand(object source, DataListCommandEventArgs e)
    {
        string connectionString =
            WebConfigurationManager.ConnectionStrings["AdventureWorks"].ConnectionString;
        string updateSQL = "UPDATE saleslt.product SET Name=@pname WHERE productid=@pid";

        SqlConnection conn = new SqlConnection(connectionString);
        SqlCommand cmd = new SqlCommand(updateSQL, conn);

        TextBox txtName = (TextBox)e.Item.FindControl("txtProductName");
        TextBox txtPID = (TextBox)e.Item.FindControl("txtProductID");
        
        cmd.Parameters.AddWithValue("@pname", txtName.Text);
        cmd.Parameters.AddWithValue("@pid", txtPID.Text);

        try
        {
            conn.Open();
            cmd.ExecuteNonQuery();
        }
        finally
        {
            conn.Close();
        }

        dlstProduct.EditItemIndex = -1;

        dlstProduct.DataSource = dsrcProduct;
        dlstProduct.DataBind();
    }

    protected void dlstProduct_CancelCommand(object source, DataListCommandEventArgs e)
    {
        dlstProduct.EditItemIndex = -1;

        dlstProduct.DataSource = dsrcProduct;
        dlstProduct.DataBind();
    }
}
